Index: /EcnlProtoTool/trunk/ntshell/src/socket_stub.c
===================================================================
--- /EcnlProtoTool/trunk/ntshell/src/socket_stub.c	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/src/socket_stub.c	(revision 441)
@@ -814,22 +1930,216 @@
 }
 
-size_t udp_fd_read(struct _IO_FILE *fp, unsigned char *dst, size_t dstsz)
-{
-	return shell_recv(fp->fd, dst, dstsz, 0);
-}
-
-size_t udp_fd_write(struct _IO_FILE *fp, const unsigned char *src, size_t srcsz)
-{
-	return shell_send(fp->fd, src, srcsz, 0);
-}
-
-off_t udp_fd_seek(struct _IO_FILE *fp, off_t ofs, int org)
+size_t udp_fd_read(struct SHELL_FILE *fp, unsigned char *dst, size_t dstsz)
+{
+	return shell_recvfrom(fp->fd, dst, dstsz, 0, NULL, NULL);
+}
+
+size_t udp_fd_write(struct SHELL_FILE *fp, const unsigned char *src, size_t srcsz)
+{
+	return shell_sendto(fp->fd, src, srcsz, 0, NULL, 0);
+}
+
+off_t udp_fd_seek(struct SHELL_FILE *fp, off_t ofs, int org)
 {
 	return -EPERM;
 }
 
-int udp_fd_ioctl(struct _IO_FILE *fp, int req, void *arg)
+int udp_fd_ioctl(struct SHELL_FILE *fp, int req, void *arg)
 {
 	return -EINVAL;
+}
+
+bool_t udp_fd_readable(struct SHELL_FILE *fp)
+{
+	socket_t *socket = (socket_t *)fp->exinf;
+	if (socket->cepid != 0) {
+		if (socket->input != NULL) {
+			return true;
+		}
+	}
+
+	return false;
+}
+
+bool_t udp_fd_writable(struct SHELL_FILE *fp)
+{
+	//socket_t *socket = (socket_t *)fp->exinf;
+
+	return fp->writable && (fp->writeevt_w == fp->writeevt_r);
+}
+
+void udp_fd_delete(struct SHELL_FILE *fp)
+{
+	//socket_t *socket = (socket_t *)fp->exinf;
+	//free(socket->buf);
+	//socket->buf = NULL;
+	free(fp->exinf);
+	fp->exinf = NULL;
+}
+
+ER socket_udp_callback(ID cepid, FN fncd, void *p_parblk)
+{
+	struct SHELL_FILE *fp = id_to_fd(&IO_TYPE_UDP, cepid);
+	FLGPTN flgptn = 0;
+	int len;
+
+	if (fp == NULL)
+		return E_PAR;
+
+	int fd = fp->fd;
+	FD_SET(fd, (fd_set *)&flgptn);
+
+	switch (fncd) {
+	case TEV_UDP_RCV_DAT:
+	{
+		T_UDP_RCV_DAT_PARA *udppara = (T_UDP_RCV_DAT_PARA *)p_parblk;
+		len = udppara->len;
+		if ((len <= 0) || (fp->exinf == NULL))
+			return E_OK;
+
+		ER ret = wai_sem(SEM_FILEDESC);
+		if (ret < 0) {
+			syslog(LOG_ERROR, "wai_sem => %d", ret);
+		}
+		socket_t *socket = (socket_t *)fp->exinf;
+		socket->len = len;
+		if (socket->input != NULL) {
+			ret = rel_net_buf(socket->input);
+			if (ret < 0) {
+				syslog(LOG_ERROR, "rel_net_buf => %d", ret);
+			}
+		}
+		socket->input = udppara->input;
+		socket->buf = GET_UDP_SDU(udppara->input, udppara->off);
+		memset(&socket->raddr4, 0, sizeof(struct sockaddr_in));
+		socket->raddr4.sin_family = AF_INET;
+		socket->raddr4.sin_port = htons(udppara->rep4.portno);
+		socket->raddr4.sin_addr.s_addr = htonl(udppara->rep4.ipaddr);
+		udppara->input->flags |= NB_FLG_NOREL_IFOUT;
+		ret = sig_sem(SEM_FILEDESC);
+		if (ret < 0) {
+			syslog(LOG_ERROR, "sig_sem => %d", ret);
+		}
+
+		if (fp->readevt_w == fp->readevt_r) fp->readevt_w++;
+
+		set_flg(FLG_SELECT_WAIT, flgptn);
+		return E_OK;
+	}
+	case TFN_UDP_CRE_CEP:
+		return E_OK;
+
+	case TFN_UDP_RCV_DAT:
+		len = *(int *)p_parblk;
+		if ((len <= 0) || (fp->exinf == NULL))
+			return E_OK;
+
+		if (fp->readevt_w == fp->readevt_r) fp->readevt_w++;
+
+		set_flg(FLG_SELECT_WAIT, flgptn);
+		return E_OK;
+
+	case TFN_UDP_SND_DAT:
+		if (fp->writeevt_w == fp->writeevt_r) fp->writeevt_w++;
+
+		set_flg(FLG_SELECT_WAIT, flgptn);
+		return E_OK;
+
+	case TFN_UDP_CAN_CEP:
+		if (fp->errorevt_w == fp->errorevt_r) fp->errorevt_w++;
+
+		set_flg(FLG_SELECT_WAIT, flgptn);
+		return E_OK;
+
+	case TFN_UDP_DEL_CEP:
+		delete_fd_by_id(&IO_TYPE_UDP, cepid);
+		return E_OK;
+
+	default:
+		return E_OK;
+	}
+}
+
+ER socket_udp6_callback(ID cepid, FN fncd, void *p_parblk)
+{
+	struct SHELL_FILE *fp = id_to_fd(&IO_TYPE_UDP, cepid);
+	FLGPTN flgptn = 0;
+	int len;
+
+	if (fp == NULL)
+		return E_PAR;
+
+	int fd = fp->fd;
+	FD_SET(fd, (fd_set *)&flgptn);
+
+	switch (fncd) {
+	case TEV_UDP_RCV_DAT:
+	{
+		T_UDP_RCV_DAT_PARA *udppara = (T_UDP_RCV_DAT_PARA *)p_parblk;
+		len = udppara->len;
+		if ((len <= 0) || (fp->exinf == NULL))
+			return E_OK;
+
+		ER ret = wai_sem(SEM_FILEDESC);
+		if (ret < 0) {
+			syslog(LOG_ERROR, "wai_sem => %d", ret);
+		}
+		socket_t *socket = (socket_t *)fp->exinf;
+		socket->len = len;
+		if (socket->input != NULL) {
+			ret = rel_net_buf(socket->input);
+			if (ret < 0) {
+				syslog(LOG_ERROR, "rel_net_buf => %d", ret);
+			}
+		}
+		socket->input = udppara->input;
+		socket->buf = GET_UDP_SDU(udppara->input, udppara->off);
+		memset(&socket->raddr6, 0, sizeof(struct sockaddr_in6));
+		socket->raddr6.sin6_family = AF_INET;
+		socket->raddr6.sin6_port = htons(udppara->rep6.portno);
+		addrcpy(&socket->raddr6.sin6_addr, &udppara->rep6.ipaddr, 16);
+		udppara->input->flags |= NB_FLG_NOREL_IFOUT;
+		ret = sig_sem(SEM_FILEDESC);
+		if (ret < 0) {
+			syslog(LOG_ERROR, "sig_sem => %d", ret);
+		}
+
+		if (fp->readevt_w == fp->readevt_r) fp->readevt_w++;
+
+		set_flg(FLG_SELECT_WAIT, flgptn);
+		return E_OK;
+	}
+	case TFN_UDP_CRE_CEP:
+		return E_OK;
+
+	case TFN_UDP_RCV_DAT:
+		len = *(int *)p_parblk;
+		if ((len <= 0) || (fp->exinf == NULL))
+			return E_OK;
+
+		if (fp->readevt_w == fp->readevt_r) fp->readevt_w++;
+
+		set_flg(FLG_SELECT_WAIT, flgptn);
+		return E_OK;
+
+	case TFN_UDP_SND_DAT:
+		if (fp->writeevt_w == fp->writeevt_r) fp->writeevt_w++;
+
+		set_flg(FLG_SELECT_WAIT, flgptn);
+		return E_OK;
+
+	case TFN_UDP_CAN_CEP:
+		if (fp->errorevt_w == fp->errorevt_r) fp->errorevt_w++;
+
+		set_flg(FLG_SELECT_WAIT, flgptn);
+		return E_OK;
+
+	case TFN_UDP_DEL_CEP:
+		delete_fd_by_id(&IO_TYPE_UDP, cepid);
+		return E_OK;
+
+	default:
+		return E_OK;
+	}
 }
 
@@ -904,2 +2214,48 @@
 }
 #endif
+
+// musl-1.1.18/network/lookup.h
+struct address {
+	int family;
+	unsigned scopeid;
+	uint8_t addr[16];
+	int sortkey;
+};
+
+#define MAXNS 3
+
+struct resolvconf {
+	struct address ns[MAXNS];
+	unsigned nns, attempts, ndots;
+	unsigned timeout;
+};
+
+// musl-1.1.18/network/resolvconf.c
+int __get_resolv_conf(struct resolvconf *conf, char *search, size_t search_sz)
+{
+	int nns = 0;
+
+	conf->ndots = 1;
+	conf->timeout = 5;
+	conf->attempts = 2;
+	if (search) *search = 0;
+
+#if defined(SUPPORT_INET4)
+	T_IN4_ADDR	in4_addr;
+	conf->ns[nns].family = AF_INET;
+	conf->ns[nns].scopeid = 0;
+	dns_in4_get_addr(&in4_addr);
+	*(uint32_t *)conf->ns[nns].addr = ntohl(in4_addr);
+	nns++;
+#endif
+
+#if defined(SUPPORT_INET6)
+	conf->ns[nns].family = AF_INET6;
+	conf->ns[nns].scopeid = 0;
+	dns_in6_get_addr((T_IN6_ADDR *)conf->ns[nns].addr);
+	nns++;
+#endif
+	conf->nns = nns;
+
+	return 0;
+}
Index: /EcnlProtoTool/trunk/ntshell/src/stdio_stub.c
===================================================================
--- /EcnlProtoTool/trunk/ntshell/src/stdio_stub.c	(revision 441)
+++ /EcnlProtoTool/trunk/ntshell/src/stdio_stub.c	(revision 441)
@@ -0,0 +1,666 @@
+/*
+ *  TOPPERS PROJECT Home Network Working Group Software
+ * 
+ *  Copyright (C) 2017-2019 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id$
+ */
+#include "shellif.h"
+#include <stdint.h>
+#include <kernel.h>
+#include <t_syslog.h>
+#include <t_stdlib.h>
+#include <sil.h>
+#include "syssvc/serial.h"
+#include "syssvc/syslog.h"
+#include "target_syssvc.h"
+#include "fdtable.h"
+#include "kernel_cfg.h"
+#include <string.h>
+#include <errno.h>
+#include "util/ntstdio.h"
+#include "hal/serial_api.h"
+#include "target_rename.h"
+#include "target_kernel_impl.h"
+#include "syssvc/siofd.h"
+
+#ifdef _DEBUG
+static const char THIS_FILE[] = __FILE__;
+#endif
+
+int shell_errno;
+
+extern bool_t sio_isr_snd(ID siopid);
+extern bool_t sio_isr_rcv(ID siopid, char c);
+
+static unsigned char stdio_xi(struct ntstdio_t *handle);
+static void stdio_xo(struct ntstdio_t *handle, unsigned char c);
+static void stdio_serial_irq_handler(uint32_t id, SerialIrq event);
+
+static int stdio_close(struct SHELL_FILE *fp);
+static size_t stdio_read(struct SHELL_FILE *fp, unsigned char *data, size_t len);
+static size_t stdio_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len);
+static void stdio_delete(struct SHELL_FILE *fp);
+
+static unsigned char sio_xi(struct ntstdio_t *handle);
+static void sio_xo(struct ntstdio_t *handle, unsigned char c);
+static void sio_serial_irq_handler(uint32_t id, SerialIrq event);
+
+static int sio_close(struct SHELL_FILE *fp);
+static size_t sio_read(struct SHELL_FILE *fp, unsigned char *data, size_t len);
+static size_t sio_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len);
+static off_t sio_seek(struct SHELL_FILE *fp, off_t ofs, int org);
+static int sio_ioctl(struct SHELL_FILE *fp, int req, void *arg);
+static bool_t sio_readable(struct SHELL_FILE *fp);
+static bool_t sio_writable(struct SHELL_FILE *fp);
+static void sio_delete(struct SHELL_FILE *fp);
+
+IO_TYPE IO_TYPE_STDIN = { stdio_close, sio_read, stdio_write, sio_seek, sio_ioctl, sio_readable, sio_writable, stdio_delete };
+IO_TYPE IO_TYPE_STDOUT = { stdio_close, stdio_read, sio_write, sio_seek, sio_ioctl, sio_readable, sio_writable, stdio_delete };
+IO_TYPE IO_TYPE_STDERR = { stdio_close, stdio_read, sio_write, sio_seek, sio_ioctl, sio_readable, sio_writable, stdio_delete };
+IO_TYPE IO_TYPE_SIO = { sio_close, sio_read, sio_write, sio_seek, sio_ioctl, sio_readable, sio_writable, sio_delete };
+
+#define STDIO_UART_BUF_SZ 256
+
+typedef struct stdio_sio_t {
+	serial_t serial;
+	ntstdio_t ntstdio;
+	struct SHELL_FILE *fp;
+	unsigned char tx_buf[STDIO_UART_BUF_SZ];
+	int tx_pos_w;
+	int tx_pos_r;
+	unsigned char rx_buf[STDIO_UART_BUF_SZ];
+	int rx_pos_w;
+	int rx_pos_r;
+} stdio_sio_t;
+
+stdio_sio_t stdio_sio;
+ntstdio_t *ntstdio = &stdio_sio.ntstdio;
+
+void sys_init(intptr_t exinf)
+{
+	serial_t *serial = &stdio_sio.serial;
+	ntstdio_t *ntstdio = &stdio_sio.ntstdio;
+
+	serial_init(serial, STDIO_UART_TX, STDIO_UART_RX);
+	serial_baud(serial, UART_BAUDRATE);
+	serial_format(serial, 8, ParityNone, 1);
+
+	ntstdio_init(ntstdio, NTSTDIO_OPTION_LINE_ECHO | NTSTDIO_OPTION_CANON | NTSTDIO_OPTION_LF_CRLF | NTSTDIO_OPTION_LF_CR, stdio_xi, stdio_xo);
+	ntstdio->exinf = (void *)&stdio_sio;
+
+	struct SHELL_FILE *fp;
+
+	fp = fd_to_fp(STDIN_FILENO);
+	fp->handle = SIO_PORTID;
+	fp->exinf = (void *)ntstdio;
+
+	fp = fd_to_fp(STDOUT_FILENO);
+	fp->handle = SIO_PORTID;
+	fp->exinf = (void *)ntstdio;
+
+	fp = fd_to_fp(STDERR_FILENO);
+	fp->handle = SIO_PORTID;
+	fp->exinf = (void *)ntstdio;
+
+	serial_irq_handler(&stdio_sio.serial, stdio_serial_irq_handler, 0);
+
+	serial_irq_set(serial, RxIrq, true);
+}
+
+void stdio_open(ID portid)
+{
+	struct SHELL_FILE *fp;
+
+	serial_ctl_por(portid, IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV);
+
+	fp = fd_to_fp(STDIN_FILENO);
+	fp->handle = portid;
+
+	fp = fd_to_fp(STDOUT_FILENO);
+	fp->handle = portid;
+
+	fp = fd_to_fp(STDERR_FILENO);
+	fp->handle = portid;
+}
+
+int stdio_close(struct SHELL_FILE *fp)
+{
+	return -EPERM;
+}
+
+size_t stdio_read(struct SHELL_FILE *fp, unsigned char *data, size_t len)
+{
+	return -EPERM;
+}
+
+size_t stdio_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len)
+{
+	return -EPERM;
+}
+
+void stdio_delete(struct SHELL_FILE *fp)
+{
+}
+
+int sio_close(struct SHELL_FILE *fp)
+{
+	return -EPERM;
+}
+
+size_t sio_read(struct SHELL_FILE *fp, unsigned char *data, size_t len)
+{
+	int i = 0;
+	while (i < len) {
+		int c = ntstdio_getc((struct ntstdio_t *)fp->exinf);
+		data[i++] = c;
+		if ((c == EOF) || (c == '\n'))
+			break;
+	}
+	return i;
+}
+
+size_t sio_write(struct SHELL_FILE *fp, const unsigned char *data, size_t len)
+{
+	for (int i = 0; i < len; i++) {
+		ntstdio_putc((struct ntstdio_t *)fp->exinf, data[i]);
+	}
+	return len;
+}
+
+off_t sio_seek(struct SHELL_FILE *fp, off_t ofs, int org)
+{
+	return -EPERM;
+}
+
+int sio_tcgetattr(struct SHELL_FILE *fp, struct termios *termios)
+{
+	ntstdio_t *ntstdio = (ntstdio_t *)fp->exinf;
+
+	memset(termios, 0, sizeof(*termios));
+
+	if (ntstdio->option & NTSTDIO_OPTION_LINE_ECHO) {
+		termios->c_lflag |= ECHO;
+	}
+	else {
+		termios->c_lflag &= ~ECHO;
+	}
+	if (ntstdio->option & NTSTDIO_OPTION_CANON) {
+		termios->c_lflag |= ICANON;
+	}
+	else {
+		termios->c_lflag &= ~ICANON;
+	}
+	if (ntstdio->option & NTSTDIO_OPTION_LF_CR) {
+		termios->c_iflag |= INLCR;
+	}
+	else {
+		termios->c_iflag &= ~INLCR;
+	}
+	if (ntstdio->option & NTSTDIO_OPTION_LF_CRLF) {
+		termios->c_oflag |= ONLCR;
+	}
+	else {
+		termios->c_oflag &= ~ONLCR;
+	}
+
+	return 0;
+}
+
+int sio_tcsetattr(struct SHELL_FILE *fp, int optional_actions, const struct termios *termios)
+{
+	ntstdio_t *ntstdio = (ntstdio_t *)fp->exinf;
+
+	if (optional_actions == TCSANOW) {
+		if (termios->c_lflag & ECHO) {
+			ntstdio->option |= NTSTDIO_OPTION_LINE_ECHO;
+		}
+		else {
+			ntstdio->option &= ~NTSTDIO_OPTION_LINE_ECHO;
+		}
+		if (termios->c_lflag & ICANON) {
+			ntstdio->option |= NTSTDIO_OPTION_CANON;
+		}
+		else {
+			ntstdio->option &= ~NTSTDIO_OPTION_CANON;
+		}
+		if (termios->c_iflag & INLCR) {
+			ntstdio->option |= NTSTDIO_OPTION_LF_CR;
+		}
+		else {
+			ntstdio->option &= ~NTSTDIO_OPTION_LF_CR;
+		}
+		if (termios->c_oflag & ONLCR) {
+			ntstdio->option |= NTSTDIO_OPTION_LF_CRLF;
+		}
+		else {
+			ntstdio->option &= ~NTSTDIO_OPTION_LF_CRLF;
+		}
+		return 0;
+	}
+
+	//shell_abort();
+	return 0;
+}
+
+int sio_ioctl(struct SHELL_FILE *fp, int request, void *arg)
+{
+	switch (request) {
+	case TIOCGWINSZ:
+		return 0;
+	case TCGETS:
+		return sio_tcgetattr(fp, (struct termios *)arg);
+	case TCSETS + TCSANOW:
+	case TCSETS + TCSADRAIN:
+	case TCSETS + TCSAFLUSH:
+		return sio_tcsetattr(fp, request - TCSETS, (const struct termios *)arg);
+	}
+
+	return -EINVAL;
+}
+
+bool_t sio_readable(struct SHELL_FILE *fp)
+{
+	struct ntstdio_t *ntstdio = (struct ntstdio_t *)fp->exinf;
+	stdio_sio_t *uart = (stdio_sio_t *)ntstdio->exinf;
+
+	return uart->rx_pos_r != uart->rx_pos_w;
+}
+
+bool_t sio_writable(struct SHELL_FILE *fp)
+{
+	if (!fp->writable)
+		return false;
+
+	struct ntstdio_t *ntstdio = (struct ntstdio_t *)fp->exinf;
+	stdio_sio_t *uart = (stdio_sio_t *)ntstdio->exinf;
+
+	int tx_pos_w = uart->tx_pos_w + 1;
+	if (tx_pos_w >= sizeof(uart->tx_buf))
+		tx_pos_w = 0;
+	return uart->tx_pos_r != tx_pos_w;
+}
+
+void sio_delete(struct SHELL_FILE *fp)
+{
+	free((stdio_sio_t *)((struct ntstdio_t *)fp->exinf)->exinf);
+	((struct ntstdio_t *)fp->exinf)->exinf = NULL;
+	free((struct ntstdio_t *)fp->exinf);
+	fp->exinf = NULL;
+}
+
+static unsigned char ntstdio_xi(struct ntstdio_t *handle, struct SHELL_FILE *fp)
+{
+	stdio_sio_t *uart = (stdio_sio_t *)handle->exinf;
+	ER ret;
+	unsigned char c;
+
+	bool_t lock = sense_lock();
+	if (lock)
+		unl_cpu();
+
+	while (uart->rx_pos_w == uart->rx_pos_r) {
+		FLGPTN flgptn = 0, waitptn = 0;
+		FD_SET(fp->fd, (fd_set *)&waitptn);
+
+		ret = wai_flg(FLG_SELECT_WAIT, waitptn, TWF_ORW, &flgptn);
+		if (ret != E_OK) {
+			if (lock)
+				loc_cpu();
+			syslog(LOG_ERROR, "wai_flg => %d", ret);
+			return 0;
+		}
+
+		ret = clr_flg(FLG_SELECT_WAIT, ~(flgptn & waitptn));
+		if (ret != E_OK) {
+			syslog(LOG_ERROR, "clr_flg => %d", ret);
+		}
+	}
+
+	if (lock)
+		unl_cpu();
+
+	c = uart->rx_buf[uart->rx_pos_r++];
+	if (uart->rx_pos_r >= sizeof(uart->rx_buf))
+		uart->rx_pos_r = 0;
+
+	if ((uart->rx_pos_r == uart->rx_pos_w)
+		&& (fp->readevt_w != fp->readevt_r))
+		fp->readevt_r++;
+
+	return c;
+}
+
+void stdio_input(unsigned char c)
+{
+	struct SHELL_FILE *fp = fd_to_fp(STDIN_FILENO);
+	stdio_sio_t *uart = (stdio_sio_t *)((struct ntstdio_t *)fp->exinf)->exinf;
+	serial_t *serial = (serial_t *)&uart->serial;
+	ER ret;
+	FLGPTN flgptn = 0;
+
+	uart->rx_buf[uart->rx_pos_w++] = c;
+	if (uart->rx_pos_w >= sizeof(uart->rx_buf))
+		uart->rx_pos_w = 0;
+
+	if (fp->readevt_w == fp->readevt_r) fp->readevt_w++;
+
+	FD_SET(STDIN_FILENO, (fd_set *)&flgptn);
+
+	ret = set_flg(FLG_SELECT_WAIT, flgptn);
+	if (ret != E_OK) {
+		syslog(LOG_ERROR, "set_flg => %d", ret);
+	}
+}
+
+static void serial_rx_irq_handler(int fd)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	stdio_sio_t *uart = (stdio_sio_t *)((struct ntstdio_t *)fp->exinf)->exinf;
+	serial_t *serial = (serial_t *)&uart->serial;
+
+	if (serial_readable(serial)) {
+		unsigned char c = (unsigned char)serial_getc(serial);
+
+		if (fd != STDIN_FILENO) {
+			ER ret;
+			FLGPTN flgptn = 0;
+
+			uart->rx_buf[uart->rx_pos_w++] = c;
+			if (uart->rx_pos_w >= sizeof(uart->rx_buf))
+				uart->rx_pos_w = 0;
+
+			if (fp->readevt_w == fp->readevt_r) fp->readevt_w++;
+
+			FD_SET(fd, (fd_set *)&flgptn);
+
+			ret = set_flg(FLG_SELECT_WAIT, flgptn);
+			if (ret != E_OK) {
+				syslog(LOG_ERROR, "set_flg => %d", ret);
+			}
+		}
+		else
+			sio_isr_rcv(fp->handle, c);
+	}
+}
+
+static void ntstdio_xo(struct ntstdio_t *handle, struct SHELL_FILE *fp, unsigned char c)
+{
+	stdio_sio_t *uart = (stdio_sio_t *)handle->exinf;
+	serial_t *serial = (serial_t *)&uart->serial;
+	ER ret;
+
+	// タスクコンテキストでない場合
+	if (sense_context()) {
+		// 送信可能になるまで待ち
+		while (!serial_writable(serial));
+		// 送信する
+		serial_putc(serial, c);
+		return;
+	}
+
+	// 送信バッファが空で
+	if (uart->tx_pos_w == uart->tx_pos_r) {
+		// 送信可能なら
+		if (serial_writable(serial)) {
+			// 送信する
+			serial_putc(serial, c);
+			return;
+		}
+	}
+
+	// 送信バッファに追加する
+	uart->tx_buf[uart->tx_pos_w++] = c;
+	if (uart->tx_pos_w >= sizeof(uart->tx_buf))
+		uart->tx_pos_w = 0;
+
+	// 送信可能になったら割り込みをもらうよう設定
+	serial_irq_set(serial, TxIrq, true);
+
+	bool_t lock = sense_lock();
+	if (lock)
+		unl_cpu();
+
+	// 送信バッファが一杯なら
+	int tx_pos_w = uart->tx_pos_w + 1;
+	if (tx_pos_w >= sizeof(uart->tx_buf))
+		tx_pos_w = 0;
+	while (tx_pos_w == uart->tx_pos_r) {
+		FLGPTN flgptn = 0, waitptn = 0;
+		FD_SET(fp->fd, (fd_set *)&waitptn);
+
+		// 送信完了割り込みまで待つ
+		ret = twai_flg(FLG_SELECT_WAIT, waitptn, TWF_ORW, &flgptn, 1000);
+		if ((ret != E_OK) && (ret != E_TMOUT)) {
+			syslog(LOG_ERROR, "wai_flg => %d", ret);
+			break;
+		}
+
+		ret = clr_flg(FLG_SELECT_WAIT, ~(flgptn & waitptn));
+		if (ret != E_OK) {
+			syslog(LOG_ERROR, "clr_flg => %d", ret);
+		}
+	}
+
+	if (fp->writeevt_w != fp->writeevt_r) fp->writeevt_r++;
+
+	if (lock)
+		loc_cpu();
+}
+
+static void serial_tx_irq_handler(int fd)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	stdio_sio_t *uart = (stdio_sio_t *)((struct ntstdio_t *)fp->exinf)->exinf;
+	serial_t *serial = (serial_t *)&uart->serial;
+	ER ret;
+	unsigned char c;
+
+	if (fp->writeevt_w == fp->writeevt_r) fp->writeevt_w++;
+
+	FLGPTN flgptn = 0;
+	FD_SET(fd, (fd_set *)&flgptn);
+
+	ret = set_flg(FLG_SELECT_WAIT, flgptn);
+	if (ret != E_OK) {
+		syslog(LOG_ERROR, "set_flg => %d", ret);
+	}
+
+	// 送信バッファが空なら
+	if (uart->tx_pos_w == uart->tx_pos_r) {
+		// SIOドライバの送信
+		sio_isr_snd(fp->handle);
+		// やっぱり送信バッファが空なら
+		if (uart->tx_pos_w == uart->tx_pos_r) {
+			// 送信割り込み停止
+			serial_irq_set(serial, TxIrq, false);
+			return;
+		}
+	}
+
+	c = uart->tx_buf[uart->tx_pos_r++];
+	if (uart->tx_pos_r >= sizeof(uart->tx_buf))
+		uart->tx_pos_r = 0;
+
+	// 送信する
+	serial_putc(serial, c);
+}
+
+void stdio_serial_irq_handler(uint32_t id, SerialIrq event)
+{
+	switch (event) {
+	case RxIrq:
+		serial_rx_irq_handler(STDIN_FILENO);
+		break;
+	case TxIrq:
+		serial_tx_irq_handler(STDOUT_FILENO);
+		break;
+	}
+}
+
+void sio_serial_irq_handler(uint32_t id, SerialIrq event)
+{
+	struct SHELL_FILE *fp = fd_to_fp(id);
+	if ((fp == NULL) || (fp->type != &IO_TYPE_SIO))
+		return;
+
+	switch (event) {
+	case RxIrq:
+		serial_rx_irq_handler(id);
+		break;
+	case TxIrq:
+		serial_tx_irq_handler(id);
+		break;
+	}
+}
+
+unsigned char stdio_xi(struct ntstdio_t *handle)
+{
+	return ntstdio_xi(handle, fd_to_fp(STDIN_FILENO));
+}
+
+void stdio_xo(struct ntstdio_t *handle, unsigned char c)
+{
+	ntstdio_xo(handle, fd_to_fp(STDOUT_FILENO), c);
+}
+
+unsigned char sio_xi(struct ntstdio_t *handle)
+{
+	return ntstdio_xi(handle, ((stdio_sio_t *)handle->exinf)->fp);
+}
+
+void sio_xo(struct ntstdio_t *handle, unsigned char c)
+{
+	ntstdio_xo(handle, ((stdio_sio_t *)handle->exinf)->fp, c);
+}
+
+int siofd_open(const char *path, int flags, ...)
+{
+	return -1;
+}
+
+int siofd_close(int fd)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	if ((fp == NULL) || (fp->type != &IO_TYPE_SIO)) {
+		shell_errno = EBADF;
+		return -1;
+	}
+
+	shell_errno = sio_close(fp);
+	if (shell_errno != 0)
+		return 1;
+	return 0;
+}
+
+ssize_t siofd_read(int fd, void *data, size_t len)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDIN) && (fp->type != &IO_TYPE_SIO))) {
+		shell_errno = EBADF;
+		return -1;
+	}
+	char *pos, *end;
+
+	for (pos = (char *)data, end = &pos[len]; pos < end; pos++) {
+		*pos = ntstdio_xi((struct ntstdio_t *)fp->exinf, fp);
+	}
+
+	return pos - (char *)data;
+}
+
+ssize_t siofd_write(int fd, const void *data, size_t len)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDOUT) && (fp->type != &IO_TYPE_STDERR)
+		&& (fp->type != &IO_TYPE_SIO))) {
+		shell_errno = EBADF;
+		return -1;
+	}
+	const char *pos, *end;
+
+	for (pos = (const char *)data, end = &pos[len]; pos < end; pos++) {
+		ntstdio_xo((struct ntstdio_t *)fp->exinf, fp, *pos);
+	}
+
+	return pos - (char *)data;
+}
+
+int siofd_tcsetattr(int fd, int act, const struct termios *tio)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDIN) && (fp->type != &IO_TYPE_STDOUT)
+		&& (fp->type != &IO_TYPE_STDERR) && (fp->type != &IO_TYPE_SIO))) {
+		shell_errno = EBADF;
+		return -1;
+	}
+
+	shell_errno = sio_tcsetattr(fp, act, tio);
+	if (shell_errno != 0)
+		return 1;
+	return 0;
+}
+
+int siofd_tcgetattr(int fd, struct termios *tio)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDIN) && (fp->type != &IO_TYPE_STDOUT)
+		&& (fp->type != &IO_TYPE_STDERR) && (fp->type != &IO_TYPE_SIO))) {
+		shell_errno = EBADF;
+		return -1;
+	}
+
+	shell_errno = sio_tcgetattr(fp, tio);
+	if (shell_errno != 0)
+		return 1;
+	return 0;
+}
+
+int siofd_fcntl(int fd, int cmd, ...)
+{
+	struct SHELL_FILE *fp = fd_to_fp(fd);
+	if ((fp == NULL) || ((fp->type != &IO_TYPE_STDIN) && (fp->type != &IO_TYPE_STDOUT)
+		&& (fp->type != &IO_TYPE_STDERR) && (fp->type != &IO_TYPE_SIO))) {
+		shell_errno = EBADF;
+		return -1;
+	}
+	void *arg;
+	va_list ap;
+	va_start(ap, cmd);
+	arg = va_arg(ap, void *);
+	va_end(ap);
+
+	shell_errno = sio_ioctl(fp, cmd, arg);
+	if (shell_errno != 0)
+		return 1;
+	return 0;
+}
Index: /EcnlProtoTool/trunk/ntshell/src/syscall.c
===================================================================
--- /EcnlProtoTool/trunk/ntshell/src/syscall.c	(revision 440)
+++ /EcnlProtoTool/trunk/ntshell/src/syscall.c	(revision 441)
@@ -101,5 +101,5 @@
 	switch (r->n) {
 	case SYS__llseek:
-		return shell_llseek(r->a, (((off_t)r->b) << 32) + (off_t)r->c, (off_t *)r->d, r->e);
+		ret = shell_llseek(r->a, (((off_t)r->b) << 32) + (off_t)r->c, (off_t *)r->d, r->e);
 	case SYS__newselect:
 		ret = shell_select(r->a, (fd_set *)r->b, (fd_set *)r->c, (fd_set *)r->d, (struct timeval *)r->e);
@@ -359,5 +359,5 @@
 		break;
 	case SYS_gettid:
-		no_implement("gettid\n");
+		ret = shell_gettid();
 		break;
 	case SYS_gettimeofday:
@@ -439,5 +439,5 @@
 		break;
 	case SYS_lstat64:
-		ret = shell_lstat((const char *__restrict)r->a, (struct stat *__restrict)r->b);
+		ret = shell_lstat((const char *restrict)r->a, (struct stat *restrict)r->b);
 		break;
 	case SYS_madvise:
@@ -472,5 +472,5 @@
 		break;
 	case SYS_mprotect:
-		return shell_mprotect((void *)r->a, (size_t)r->b, r->c);
+		ret = shell_mprotect((void *)r->a, (size_t)r->b, r->c);
 		break;
 	case SYS_mq_getsetattr:
@@ -520,5 +520,5 @@
 		break;
 	case SYS_nanosleep:
-		no_implement("nanosleep\n");
+		ret = shell_nanosleep((const struct timespec *)r->a, (struct timespec *)r->b);
 		break;
 	case SYS_nice:
@@ -538,5 +538,5 @@
 		break;
 	case SYS_pipe:
-		no_implement("pipe\n");
+		ret = shell_pipe((int *)r->a);
 		break;
 	case SYS_pipe2:
@@ -601,11 +601,8 @@
 		break;
 	case SYS_recv:
-		ret = shell_recv(r->a, (void *)r->b, (size_t)r->c, r->d);
+		ret = shell_recvfrom(r->a, (void *)r->b, (size_t)r->c, r->d, NULL, NULL);
 		break;
 	case SYS_recvfrom:
-		if (r->e == 0)
-			ret = shell_recv(r->a, (void *)r->b, (size_t)r->c, r->d);
-		else
-			ret = shell_recvfrom(r->a, (void *)r->b, (size_t)r->c, r->d, (struct sockaddr *)r->e, (socklen_t *)r->f);
+		ret = shell_recvfrom(r->a, (void *)r->b, (size_t)r->c, r->d, (struct sockaddr *)r->e, (socklen_t *)r->f);
 		break;
 	case SYS_recvmsg:
@@ -634,5 +631,5 @@
 		break;
 	case SYS_rt_sigaction:
-		ret = shell_sigaction(r->a, (const struct sigaction *)r->b, (struct sigaction *)r->c);
+		ret = shell_sigaction(r->a, (const struct sigaction *)r->b, (struct sigaction *)r->c, (size_t)r->d);
 		break;
 	case SYS_rt_sigpending:
@@ -652,5 +649,5 @@
 		break;
 	case SYS_send:
-		ret = shell_send(r->a, (const void *)r->b, (size_t)r->c, r->d);
+		ret = shell_sendto(r->a, (const void *)r->b, (size_t)r->c, r->d, NULL, 0);
 		break;
 	case SYS_sendmsg:
@@ -658,8 +655,5 @@
 		break;
 	case SYS_sendto:
-		if (r->e == 0)
-			ret = shell_send(r->a, (const void *)r->b, (size_t)r->c, r->d);
-		else
-			ret = shell_sendto(r->a, (const void *)r->b, (size_t)r->c, r->d, (const struct sockaddr *)r->e, (socklen_t)r->f);
+		ret = shell_sendto(r->a, (const void *)r->b, (size_t)r->c, r->d, (const struct sockaddr *)r->e, (socklen_t)r->f);
 		break;
 	case SYS_setsockopt:
@@ -869,5 +863,5 @@
 		break;
 	case SYS_tkill:
-		no_implement("tkill\n");
+		ret = shell_tkill((int)r->a, (int)r->b);
 		break;
 	case SYS_truncate64:
@@ -918,4 +912,16 @@
 	case SYS_writev:
 		ret = shell_writev((int)r->a, (const struct iovec *)r->b, (size_t)r->c);
+		break;
+	case SYS_getpeername:
+		ret = shell_getpeername((int)r->a, (struct sockaddr *)r->b, (socklen_t *)r->c);
+		break;
+	case SYS_getsockname:
+		ret = shell_getsockname((int)r->a, (struct sockaddr *)r->b, (socklen_t *)r->c);
+		break;
+	case SYS_sigprocmask:
+		ret = shell_sigprocmask((int)r->a, (const sigset_t *)r->b, (sigset_t *)r->c);
+		break;
+	case SYS_sigaction:
+		ret = shell_sigaction((int)r->a, (const struct k_sigaction *)r->b, (struct k_sigaction *)r->c, (size_t)r->d);
 		break;
 	default:
Index: /EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShell.cdl
===================================================================
--- /EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShell.cdl	(revision 441)
+++ /EcnlProtoTool/trunk/ntshell/src/tSIOPortNTShell.cdl	(revision 441)
@@ -0,0 +1,119 @@
+/*
+ *  TOPPERS/ASP Kernel
+ *      Toyohashi Open Platform for Embedded Real-Time Systems/
+ *      Advanced Standard Profile Kernel
+ * 
+ *  Copyright (C) 2015 by Ushio Laboratory
+ *              Graduate School of Engineering Science, Osaka Univ., JAPAN
+ *  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		シリアルインタフェースドライバのターゲット依存部（NTShell用）
+ *		のコンポーネント記述
+ */
+
+/*
+ *  NTShell に関する定義
+ */
+import_C("termios.h");
+
+/*
+ *  SIOドライバの本体のセルタイプ
+ */
+celltype tSIOPortNTShellMain {
+	/*
+	 *  シリアルインタフェースドライバとの結合
+	 */
+	entry				sSIOPort		eSIOPort;
+	[optional] call		siSIOCBR		ciSIOCBR;
+
+	/*
+	 *  終了処理ルーチン
+	 */
+	entry	sRoutineBody	eTerminate;
+
+	attr {
+		const char	*path;				/* パス名 */
+	};
+
+	var {
+		bool_t			opened = false;	/* オープン済みフラグ */
+		struct termios	saved_term;		/* 元の端末制御情報 */
+		int_t			read_fd;		/* 読出し用ファイルディスクリプタ */
+		bool_t			rcv_flag;		/* 受信文字バッファ有効フラグ */
+		char			rcv_buf;		/* 受信文字バッファ */
+		bool_t			rcv_rdy;		/* 受信通知コールバック許可フラグ */
+		int_t			write_fd;		/* 書込み用ファイルディスクリプタ */
+		bool_t			snd_flag;		/* 送信文字バッファ有効フラグ */
+		char			snd_buf;		/* 送信文字バッファ */
+		bool_t			snd_rdy;		/* 送信通知コールバック許可フラグ */
+	};
+};
+
+/*
+ *  SIOドライバ（複合コンポーネント）のセルタイプ
+ */
+[active]
+composite tSIOPortNTShell {
+	/*
+	 *  シリアルインタフェースドライバとの結合
+	 */
+	entry				sSIOPort	eSIOPort;
+	[optional] call		siSIOCBR	ciSIOCBR;
+
+	/*
+	 *  属性の定義
+	 */
+	attr {
+		const char	*path = C_EXP("NULL");		/* パス名 */
+	};
+
+	/*
+	 *  SIOドライバの本体
+	 */
+	cell tSIOPortNTShellMain SIOPortMain {
+		path     = composite.path;
+		ciSIOCBR => composite.ciSIOCBR;
+	};
+	composite.eSIOPort => SIOPortMain.eSIOPort;
+
+	/*
+	 *  SIOドライバの終了処理ルーチン
+	 */
+	cell tTerminateRoutine TerminateSIO {
+		cTerminateRoutineBody = SIOPortMain.eTerminate;
+	};
+};
